unit Tetris;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, Menus, StdCtrls, Buttons, ComCtrls;

type
  TForm1 = class(TForm)
    T1: TTimer;
    L1: TLabel;
    L2: TLabel;
    L3: TLabel;
    SB1: TSpeedButton;
    SB2: TSpeedButton;
    MainMenu1: TMainMenu;
    N1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    SB3: TSpeedButton;
    N4: TMenuItem;
    N5: TMenuItem;
    N6: TMenuItem;
    N7: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure T1Timer(Sender: TObject);
    procedure FormKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure SB1Click(Sender: TObject);
    procedure SB2Click(Sender: TObject);
    procedure SB3Click(Sender: TObject);
    procedure N6Click(Sender: TObject);
    procedure N7Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;


  const n=9; // 
  const m=17;// 
  const rzn=70;//  T1   
  const diag=20;// 
  const w=4;// Preview
var
  Form1: TForm1;
  r:TColor=clyellow;// 
  g:TColor=clBlue;// 
  col:TColor;// 
  p:array[1..n,1..m]of TPanel;
  p1:array[1..w,1..w]of TPanel;
  x:byte;//   X
  y:byte=1;//   y
  speed:integer=700;// T1, ..   
  kol:byte=0;//:   
  score:longint=0;//
  spd:byte=1;//
  lstscr:longint;//  (   )
  F:byte;// 
  F1:byte;//  

implementation

uses Help, Autor;

{$R *.dfm}

//??//??//??//??//??//??//??//??//??//??//??//??//??//??//??//??//??//??//??//??
//======================================================================//
//??//??//??//??//??//??//??//??//??//??//??//??//??//??//??//??//??//??//??//??

//===(F=1)================================
Procedure Kubik;
begin
p[x,y].color:=col;
p[x+1,y].color:=col;
p[x,y+1].color:=col;
p[x+1,y+1].color:=col;
end;
//===(F=2)========================
Procedure stick1;
begin
p[x-1,y].color:=col;
p[x,y].color:=col;
p[x+1,y].color:=col;
p[x+2,y].color:=col;
end;
//===(F=3)=======================
Procedure Stick2;
begin
p[x+1,y].color:=col;
p[x+1,y+1].color:=col;
p[x+1,y+2].color:=col;
p[x+1,y+3].color:=col;
end;
//===(F=4)==================
Procedure LeftCorner1;
begin
p[x,y].color:=col;
p[x+1,y].color:=col;
p[x+1,y+1].color:=col;
p[x+1,y+2].color:=col;
end;
//===(F=5)============
Procedure LeftCorner2;
begin
p[x,y+1].color:=col;
p[x+1,y+1].color:=col;
p[x+2,y+1].color:=col;
p[x+2,y].color:=col;
end;
//===(F=6)============
Procedure LeftCorner3;
begin
p[x,y].color:=col;
p[x,y+1].color:=col;
p[x,y+2].color:=col;
p[x+1,y+2].color:=col;
end;
//===(F=7)=============
Procedure LeftCorner4;
begin
p[x,y].color:=col;
p[x+1,y].color:=col;
p[x+2,y].color:=col;
p[x,y+1].color:=col;
end;
//===(F=8)==================
Procedure RightCorner1;
begin
p[x,y].color:=col;
p[x+1,y].color:=col;
p[x,y+1].color:=col;
p[x,y+2].color:=col;
end;
//===(F=9)============
Procedure RightCorner2;
begin
p[x,y].color:=col;
p[x+1,y].color:=col;
p[x+2,y].color:=col;
p[x+2,y+1].color:=col;
end;
//===(F=10)============
Procedure RightCorner3;
begin
p[x+1,y].color:=col;
p[x+1,y+1].color:=col;
p[x+1,y+2].color:=col;
p[x,y+2].color:=col;
end;
//===(F=11)=============
Procedure RightCorner4;
begin
p[x,y].color:=col;
p[x,y+1].color:=col;
p[x+1,y+1].color:=col;
p[x+2,y+1].color:=col;
end;
//===(F=12)======================
Procedure LeftZigzag1;
begin
p[x,y].color:=col;
p[x+1,y].color:=col;
p[x+1,y+1].color:=col;
p[x+2,y+1].color:=col;
end;
//===(F=13)======================
Procedure LeftZigzag2;
begin
p[x,y+1].color:=col;
p[x,y+2].color:=col;
p[x+1,y].color:=col;
p[x+1,y+1].color:=col;
end;
//===(F=14)======================
Procedure RightZigzag1;
begin
p[x,y+1].color:=col;
p[x+1,y].color:=col;
p[x+1,y+1].color:=col;
p[x+2,y].color:=col;
end;
//===(F=15)======================
Procedure RightZigzag2;
begin
p[x,y].color:=col;
p[x,y+1].color:=col;
p[x+1,y+1].color:=col;
p[x+1,y+2].color:=col;
end;
//===(F=16)==================
Procedure Triada1;
begin
p[x,y+1].color:=col;
p[x+1,y+1].color:=col;
p[x+1,y].color:=col;
p[x+2,y+1].color:=col;
end;
//===(F=17)==================
Procedure Triada2;
begin
p[x,y].color:=col;
p[x,y+1].color:=col;
p[x+1,y+1].color:=col;
p[x,y+2].color:=col;
end;
//===(F=18)==================
Procedure Triada3;
begin
p[x,y].color:=col;
p[x+1,y].color:=col;
p[x+1,y+1].color:=col;
p[x+2,y].color:=col;
end;
//===(F=19)==================
Procedure Triada4;
begin
p[x+1,y].color:=col;
p[x+1,y+1].color:=col;
p[x,y+1].color:=col;
p[x+1,y+2].color:=col;
end;


//==========-==========================
//--------(F1=1)-----------------------------------
Procedure Kubik1;
begin
p1[2,2].color:=col;
p1[3,2].color:=col;
p1[2,3].color:=col;
p1[3,3].color:=col;
end;
//--------(F1=2)-----------------------------------
Procedure Stick11;
begin
p1[1,2].color:=col;
p1[2,2].color:=col;
p1[3,2].color:=col;
p1[4,2].color:=col;
end;
//--------(F1=3)-----------------------------------
Procedure Stick21;
begin
p1[2,1].color:=col;
p1[2,2].color:=col;
p1[2,3].color:=col;
p1[2,4].color:=col;
end;
//--------(F1=4)-----------------------------------
Procedure LeftCorner11;
begin
p1[1,1].color:=col;
p1[2,1].color:=col;
p1[2,2].color:=col;
p1[2,3].color:=col;
end;
//--------(F1=5)-----------------------------------
Procedure LeftCorner21;
begin
p1[3,1].color:=col;
p1[1,2].color:=col;
p1[2,2].color:=col;
p1[3,2].color:=col;
end;
//--------(F1=6)-----------------------------------
Procedure LeftCorner31;
begin
p1[1,1].color:=col;
p1[1,2].color:=col;
p1[1,3].color:=col;
p1[2,3].color:=col;
end;
//--------(F1=7)-----------------------------------
Procedure LeftCorner41;
begin
p1[1,1].color:=col;
p1[2,1].color:=col;
p1[3,1].color:=col;
p1[1,2].color:=col;
end;
//--------(F1=8)-----------------------------------
Procedure RightCorner11;
begin
p1[1,1].color:=col;
p1[2,1].color:=col;
p1[1,2].color:=col;
p1[1,3].color:=col;
end;
//--------(F1=9)-----------------------------------
Procedure RightCorner21;
begin
p1[1,1].color:=col;
p1[2,1].color:=col;
p1[3,1].color:=col;
p1[3,2].color:=col;
end;
//--------(F1=10)-----------------------------------
Procedure RightCorner31;
begin
p1[2,1].color:=col;
p1[2,2].color:=col;
p1[2,3].color:=col;
p1[1,3].color:=col;
end;
//--------(F1=11)-----------------------------------
Procedure RightCorner41;
begin
p1[1,1].color:=col;
p1[1,2].color:=col;
p1[2,2].color:=col;
p1[3,2].color:=col;
end;
//--------(F1=12)-----------------------------------
Procedure LeftZigzag11;
begin
p1[1,1].color:=col;
p1[2,1].color:=col;
p1[2,2].color:=col;
p1[3,2].color:=col;
end;
//--------(F1=13)-----------------------------------
Procedure LeftZigzag21;
begin
p1[2,1].color:=col;
p1[2,2].color:=col;
p1[1,2].color:=col;
p1[1,3].color:=col;
end;
//--------(F1=14)-----------------------------------
Procedure RightZigzag11;
begin
p1[2,1].color:=col;
p1[3,1].color:=col;
p1[1,2].color:=col;
p1[2,2].color:=col;
end;
//--------(F1=15)-----------------------------------
Procedure RightZigzag21;
begin
p1[1,1].color:=col;
p1[1,2].color:=col;
p1[2,2].color:=col;
p1[2,3].color:=col;
end;
//--------(F1=16)-----------------------------------
Procedure Triada11;
begin
p1[2,1].color:=col;
p1[1,2].color:=col;
p1[2,2].color:=col;
p1[3,2].color:=col;
end;
//--------(F1=17)-----------------------------------
Procedure Triada21;
begin
p1[1,1].color:=col;
p1[1,2].color:=col;
p1[2,2].color:=col;
p1[1,3].color:=col;
end;
//--------(F1=18)-----------------------------------
Procedure Triada31;
begin
p1[1,1].color:=col;
p1[2,1].color:=col;
p1[3,1].color:=col;
p1[2,2].color:=col;
end;
//--------(F1=19)-----------------------------------
Procedure Triada41;
begin
p1[2,1].color:=col;
p1[1,2].color:=col;
p1[2,2].color:=col;
p1[2,3].color:=col;
end;


//======================================
Procedure GameOver;
var i,j:integer;
begin
 for j:=m downto 1 do
 for i:=1 to n do
 p[i,j].color:=g;
score:=0;
x:=n div 2;
y:=1;
spd:=1;
speed:=700;
end;




//===========================================================
Procedure New;
var i,j:integer;
begin

for i:=1 to w do
for j:=1 to w do
p1[i,j].Color:=g;

F:=F1;    F1:=random(19)+1; x:=n div 2;

If (p[(n div 2)-1,2].color<>g)or(p[(n div 2),2].color<>g)or(p[(n div 2)+1,2].color<>g)then GameOver;
 case F of
 1: Kubik;
 2: Stick1;
 3: Stick2;
 4: LeftCorner1;
 5: LeftCorner2;
 6: LeftCorner3;
 7: LeftCorner4;
 8: RightCorner1;
 9: RightCorner2;
 10:RightCorner3;
 11:RightCorner4;
 12:LeftZigzag1;
 13:LeftZigzag2;
 14:RightZigzag1;
 15:RightZigzag2;
 16:Triada1;
 17:Triada2;
 18:Triada3;
 19:Triada4;
 end;//of case

case F1 of
1: Kubik1;
2: Stick11;
3: Stick21;
4: LeftCorner11;
5: LeftCorner21;
6: LeftCorner31;
7: LeftCorner41;
8: RightCorner11;
9: RightCorner21;
10:RightCorner31;
11:RightCorner41;
12:LeftZigzag11;
13:LeftZigzag21;
14:RightZigzag11;
15:RightZigzag21;
16:Triada11;
17:Triada21;
18:Triada31;
19:Triada41;
end;//of case
end;


//============================================
//   I - , J -  !!!
procedure TForm1.FormCreate(Sender: TObject);
var i,j,lef,lef2,top:integer;
begin
col:=r;
x:=n div 2;
T1.Interval:=speed;
lef:=30;
lef2:=60+diag*n;
top:=30;
for i:=1 to n do begin
for j:=1 to m do begin
p[i,j]:=TPanel.Create(self);
p[i,j].parent:=Form1;
p[i,j].top:=top;
p[i,j].width:=diag;
p[i,j].height:=diag;
p[i,j].left:=lef;
top:=top+diag;
p[i,j].show;
p[i,j].color:=g;
end;
top:=30;
lef:=lef+diag;
end;
//------Preview------------------
for i:=1 to w do begin
for j:=1 to w do begin
p1[i,j]:=TPanel.Create(self);
p1[i,j].parent:=Form1;
p1[i,j].top:=top;
p1[i,j].width:=diag;
p1[i,j].height:=diag;
p1[i,j].left:=lef2;
top:=top+diag;
p1[i,j].show;
p1[i,j].color:=g;
end;
top:=30;
lef2:=lef2+diag;
end;
F1:=random(19)+1;
New;
end;




//==========================================================//
procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;//
  Shift: TShiftState);                                      //
//==========================================================//

//=================================================================
Procedure Left;
begin
If T1.enabled then
case F of
1: If (x>1)and(p[x-1,y].color=g)and(p[x-1,y+1].color=g) then begin
                                                               col:=g; kubik;
                                                               x:=x-1;
                                                               col:=r; kubik;
                                                               end;
2: If (x-1>1) and (p[x-2,y].color=g)                     then begin
                                                               col:=g; Stick1;
                                                               x:=x-1;
                                                               col:=r; Stick1;
                                                               end;
3: If (x+1>1)and(p[x,y].color=g)and(p[x,y+1].color=g)and(p[x,y+2].color=g)and(p[x,y+3].color=g)
                                                         then begin
                                                               col:=g; Stick2;
                                                               x:=x-1;
                                                               col:=r; Stick2;
                                                               end;
4: If (x>1)and(p[x-1,y].color=g)and(p[x,y+1].color=g)and(p[x,y+2].color=g)
                                                          then begin
                                                               col:=g; LeftCorner1;
                                                               x:=x-1;
                                                               col:=r; LeftCorner1;
                                                               end;
5: If (x>1)and(p[x-1,y+1].color=g)and(p[x+1,y].color=g) then begin
                                                               col:=g; LeftCorner2;
                                                               x:=x-1;
                                                               col:=r; LeftCorner2;
                                                               end;
6: If (x>1)and(p[x-1,y].color=g)and(p[x-1,y+1].color=g)and(p[x-1,y+2].color=g)
                                                          then begin
                                                               col:=g; LeftCorner3;
                                                               x:=x-1;
                                                               col:=r; LeftCorner3;
                                                               end;
7: If (x>1)and(p[x-1,y].color=g)and(p[x-1,y+1].color=g) then begin
                                                               col:=g; LeftCorner4;
                                                               x:=x-1;
                                                               col:=r; LeftCorner4;
                                                               end;
8: If (x>1)and(p[x-1,y].color=g)and(p[x-1,y+1].color=g)and(p[x-1,y+2].color=g)
                                                          then begin
                                                               col:=g; RightCorner1;
                                                               x:=x-1;
                                                               col:=r; RightCorner1;
                                                               end;
9: If (x>1)and(p[x-1,y].color=g)and(p[x+1,y+1].color=g) then begin
                                                               col:=g; RightCorner2;
                                                               x:=x-1;
                                                               col:=r; RightCorner2;
                                                               end;
10:If (x>1)and(p[x-1,y+2].color=g)and(p[x,y+1].color=g)and(p[x,y].color=g)
                                                          then begin
                                                               col:=g; RightCorner3;
                                                               x:=x-1;
                                                               col:=r; RightCorner3;
                                                               end;
11:If (x>1)and(p[x-1,y].color=g)and(p[x-1,y+1].color=g) then begin
                                                               col:=g; RightCorner4;
                                                               x:=x-1;
                                                               col:=r; RightCorner4;
                                                               end;
12:If (x>1)and(p[x-1,y].color=g)and(p[x,y+1].color=g) then begin
                                                               col:=g; LeftZigzag1;
                                                               x:=x-1;
                                                               col:=r; LeftZigzag1;
                                                               end;
13:If (x>1)and(p[x,y].color=g)and(p[x-1,y+1].color=g)and(p[x-1,y+2].color=g)
                                                          then begin
                                                               col:=g; LeftZigzag2;
                                                               x:=x-1;
                                                               col:=r; LeftZigzag2;
                                                               end;
14:If (x>1)and(p[x,y].color=g)and(p[x-1,y+1].color=g) then begin
                                                               col:=g; RightZigzag1;
                                                               x:=x-1;
                                                               col:=r; RightZigzag1;
                                                               end;
15:If (x>1)and(p[x-1,y].color=g)and(p[x-1,y+1].color=g)and(p[x,y+2].color=g)
                                                          then begin
                                                               col:=g; RightZigzag2;
                                                               x:=x-1;
                                                               col:=r; RightZigzag2;
                                                               end;
16:If (x>1)and(p[x-1,y+1].color=g)and(p[x,y].color=g) then begin
                                                               col:=g; Triada1;
                                                               x:=x-1;
                                                               col:=r; Triada1;
                                                               end;
17:If (x>1)and(p[x-1,y].color=g)and(p[x-1,y+1].color=g)and(p[x-1,y+2].color=g)
                                                          then begin
                                                               col:=g; Triada2;
                                                               x:=x-1;
                                                               col:=r; Triada2;
                                                               end;
18:If (x>1)and(p[x-1,y].color=g)and(p[x,y+1].color=g)   then begin
                                                               col:=g; Triada3;
                                                               x:=x-1;
                                                               col:=r; Triada3;
                                                               end;
19:If (x>1)and(p[x,y].color=g)and(p[x-1,y+1].color=g)and(p[x,y+2].color=g)
                                                          then begin
                                                               col:=g; Triada4;
                                                               x:=x-1;
                                                               col:=r; Triada4;
                                                               end;

end;//of case
end;

//================================================================
Procedure Right;
begin
If T1.enabled then
case F of
1: If (x+1<n) and (p[x+2,y].color=g)and(p[x+2,y+1].color=g)
                                                            then begin
                                                                 col:=g; Kubik;
                                                                 x:=x+1;
                                                                 col:=r; kubik;
                                                                 end;
2: If (x+2<n) and (p[x+3,y].color=g)
                                                            then begin
                                                                 col:=g; Stick1;
                                                                 x:=x+1;
                                                                 col:=r; Stick1;
                                                                 end;
3: If (x+1<n)and(p[x+2,y].color=g)and(p[x+2,y+1].color=g)and(p[x+2,y+2].color=g)and(p[x+2,y+3].color=g)
                                                            then begin
                                                                 col:=g; Stick2;
                                                                 x:=x+1;
                                                                 col:=r; Stick2;
                                                                 end;
4: If (x+1<n)and(p[x+2,y].color=g)and(p[x+2,y+1].color=g)and(p[x+2,y+2].color=g)
                                                            then begin
                                                                 col:=g; LeftCorner1;
                                                                 x:=x+1;
                                                                 col:=r; LeftCorner1;
                                                                 end;
5: If (x+2<n)and(p[x+3,y].color=g)and(p[x+3,y+1].color=g)
                                                            then begin
                                                                 col:=g; LeftCorner2;
                                                                 x:=x+1;
                                                                 col:=r; LeftCorner2;
                                                                 end;
6: If (x+1<n)and(p[x+1,y].color=g)and(p[x+1,y+1].color=g)and(p[x+2,y+2].color=g)
                                                            then begin
                                                                 col:=g; LeftCorner3;
                                                                 x:=x+1;
                                                                 col:=r; LeftCorner3;
                                                                 end;
7: If (x+2<n)and(p[x+3,y].color=g)and(p[x+1,y+1].color=g)
                                                            then begin
                                                                 col:=g; LeftCorner4;
                                                                 x:=x+1;
                                                                 col:=r; LeftCorner4;
                                                                 end;
8: If (x+1<n)and(p[x+2,y].color=g)and(p[x+1,y+1].color=g)and(p[x+1,y+2].color=g)
                                                            then begin
                                                                 col:=g; RightCorner1;
                                                                 x:=x+1;
                                                                 col:=r; RightCorner1;
                                                                 end;
9: If (x+2<n)and(p[x+3,y].color=g)and(p[x+3,y+1].color=g)
                                                            then begin
                                                                 col:=g; RightCorner2;
                                                                 x:=x+1;
                                                                 col:=r; RightCorner2;
                                                                 end;
10:If (x+1<n)and(p[x+2,y].color=g)and(p[x+2,y+1].color=g)and(p[x+2,y+2].color=g)
                                                            then begin
                                                                 col:=g; RightCorner3;
                                                                 x:=x+1;
                                                                 col:=r; RightCorner3;
                                                                 end;
11:If (x+2<n)and(p[x+1,y].color=g)and(p[x+3,y+1].color=g)
                                                            then begin
                                                                 col:=g; RightCorner4;
                                                                 x:=x+1;
                                                                 col:=r; RightCorner4;
                                                                 end;
12:If (x+2<n)and(p[x+2,y].color=g)and(p[x+3,y+1].color=g)
                                                            then begin
                                                                 col:=g; LeftZigzag1;
                                                                 x:=x+1;
                                                                 col:=r; LeftZigzag1;
                                                                 end;
13:If (x+1<n)and(p[x+2,y].color=g)and(p[x+2,y+1].color=g)and(p[x+1,y+2].color=g)
                                                            then begin
                                                                 col:=g; LeftZigzag2;
                                                                 x:=x+1;
                                                                 col:=r; LeftZigzag2;
                                                                 end;
14:If (x+2<n)and(p[x+3,y].color=g)and(p[x+2,y+1].color=g)
                                                            then begin
                                                                 col:=g; RightZigzag1;
                                                                 x:=x+1;
                                                                 col:=r; RightZigzag1;
                                                                 end;
15:If (x+1<n)and(p[x+1,y].color=g)and(p[x+2,y+1].color=g)and(p[x+2,y+2].color=g)
                                                            then begin
                                                                 col:=g; RightZigzag2;
                                                                 x:=x+1;
                                                                 col:=r; RightZigzag2;
                                                                 end;
16:If (x+2<n)and(p[x+2,y].color=g)and(p[x+3,y+1].color=g)
                                                            then begin
                                                                 col:=g; Triada1;
                                                                 x:=x+1;
                                                                 col:=r; Triada1;
                                                                 end;
17:If (x+1<n)and(p[x+1,y].color=g)and(p[x+2,y+1].color=g)and(p[x+1,y+2].color=g)
                                                            then begin
                                                                 col:=g; Triada2;
                                                                 x:=x+1;
                                                                 col:=r; Triada2;
                                                                 end;
18:If (x+2<n)and(p[x+3,y].color=g)and(p[x+2,y+1].color=g)
                                                            then begin
                                                                 col:=g; Triada3;
                                                                 x:=x+1;
                                                                 col:=r; Triada3;
                                                                 end;
19:If (x+1<n)and(p[x+2,y].color=g)and(p[x+2,y+1].color=g)and(p[x+2,y+2].color=g)
                                                            then begin
                                                                 col:=g; Triada4;
                                                                 x:=x+1;
                                                                 col:=r; Triada4;
                                                                 end;

end;//of case
end;

//=====================================================================
Procedure Down;
begin
T1.Interval:=33;
end;
//=======================================================================
Procedure Rotate;
begin
If T1.enabled then
case F of
2: If (y+2<m)and(p[x+1,y+3].color=g)and(p[x+1,y+2].color=g) then
   begin
   col:=g; Stick1;
   F:=3;
   col:=r; Stick2;
   end;

3: If (x>1)and(x+1<n)and(p[x-1,y].color=g)and(p[x+2,y].color=g) then
   begin
   col:=g; Stick2;
   F:=2;
   col:=r; Stick1;
   end;

4: If (x+1<n)and(p[x+2,y].color=g)and(p[x+2,y+1].color=g) then
   begin
   col:=g; LeftCorner1;
   F:=5;
   col:=r; LeftCorner2;
   end;

5: If (y+1<m)and(p[x,y+2].color=g)and(p[x+1,y+2].color=g) then
   begin
   col:=g; LeftCorner2;
   F:=6;
   col:=r; LeftCorner3;
   end;

6: If (x+1<n)and(p[x+2,y].color=g) then
   begin
   col:=g; LeftCorner3;
   F:=7;
   col:=r; LeftCorner4;
   end;

7: If (y+1<m)and(p[x+1,y+2].color=g) then
   begin
   col:=g; LeftCorner4;
   F:=4;
   col:=r; LeftCorner1;
   end;

8: If (x+1<n)and(p[x+2,y].color=g)and(p[x+2,y+1].color=g) then
   begin
   col:=g; RightCorner1;
   F:=9;
   col:=r; RightCorner2;
   end;

9: If (y+1<m)and(p[x,y+2].color=g)and(p[x+1,y+2].color=g) then
   begin
   col:=g; RightCorner2;
   F:=10;
   col:=r; RightCorner3;
   end;

10:If (x+1<n)and(p[x+2,y+1].color=g) then
   begin
   col:=g; RightCorner3;
   F:=11;
   col:=r; RightCorner4;
   end;

11:If (y+1<m)and(p[x,y+2].color=g) then
   begin
   col:=g; RightCorner4;
   F:=8;
   col:=r; RightCorner1;
   end;

12:If (y+1<m)and(p[x,y+2].color=g) then
   begin
   col:=g; LeftZigzag1;
   F:=13;
   col:=r; LeftZigzag2;
   end;

13:If (x+1<n)and(p[x+2,y+1].color=g) then
   begin
   col:=g; LeftZigzag2;
   F:=12;
   col:=r; LeftZigzag1;
   end;

14:If (y+1<m)and(p[x+1,y+2].color=g) then
   begin
   col:=g; RightZigzag1;
   F:=15;
   col:=r; RightZigzag2;
   end;

15:If (x+1<n)and(p[x+2,y].color=g) then
   begin
   col:=g; RightZigzag2;
   F:=14;
   col:=r; RightZigzag1;
   end;

16:If (y+1<m)and(p[x,y+2].color=g) then
   begin
   col:=g; Triada1;
   F:=17;
   col:=r; Triada2;
   end;

17:If (x+1<n)and(p[x+2,y].color=g) then
   begin
   col:=g; Triada2;
   F:=18;
   col:=r; Triada3;
   end;

18:If (y+1<m)and(p[x+1,y+2].color=g) then
   begin
   col:=g; Triada3;
   F:=19;
   col:=r; Triada4;
   end;

19:If (x+1<n)and(p[x+2,y+1].color=g) then
   begin
   col:=g; Triada4;
   F:=16;
   col:=r; Triada1;
   end;



end;//of case
end;

//==============================================================================
begin
case key of
vk_left          : Left;
vk_right         : Right;
vk_down,vk_space : Down;
vk_up,vk_control : Rotate;
vk_return        : Form1.SB2.Click;
vk_Escape        : form1.SB3.Click;
end;//of case

end;
//============""============================================
procedure TForm1.FormKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 case key of
 vk_down, vk_space: T1.Interval:=speed;
 end;//of case
end;

//=======================================
Procedure Proverka;
var i,j,i1,j1:integer;
begin

for j:=1 to m do begin{1}
kol:=0;
for i:=1 to n do begin
                 If p[i,j].color<>g then kol:=kol+1;
                 end;
                     If kol=n then begin
                                   for j1:=j downto 2 do
                                   for i1:=1 to n do
                                   p[i1,j1].color:=p[i1,j1-1].color;
                                   score:=score+100;

                                   end;
end;{1}
if score>=spd*1000+lstscr then begin
                                lstscr:=score;
                                spd:=spd+1;
                                speed:=Speed-rzn;
                               end;
end;

//========================================================================
procedure TForm1.T1Timer(Sender: TObject);
begin
case F of
1: If (y+1<m)and(p[x,y+2].color=g)and(p[x+1,y+2].color=g)
                                                         then begin
                                                              col:=g; Kubik;
                                                              y:=y+1;
                                                              col:=r; Kubik;
                                                              end else
                                                              begin
                                                              proverka;
                                                              L1.caption:=': '+IntToStr(Score);
                                                              T1.Interval:=speed;
                                                              L2.caption:=': '+IntToStr(spd);
                                                              x:=4; y:=1;
                                                              New;
                                                              end;
2: If (y<m)and(p[x-1,y+1].color=g)and(p[x,y+1].color=g)and(p[x+1,y+1].color=g)and(p[x+2,y+1].color=g)
                                                         then begin
                                                              col:=g; Stick1;
                                                              y:=y+1;
                                                              col:=r; Stick1;
                                                              end else
                                                              begin
                                                              proverka;
                                                              L1.caption:=': '+IntToStr(Score);
                                                              T1.Interval:=speed;
                                                              L2.caption:=': '+IntToStr(spd);
                                                              x:=4; y:=1;
                                                              New;
                                                              end;
3: If (y+3<m) and (p[x+1,y+4].color=g)
                                                         then begin
                                                              col:=g; Stick2;
                                                              y:=y+1;
                                                              col:=r; Stick2;
                                                              end else
                                                              begin
                                                              proverka;
                                                              L1.caption:=': '+IntToStr(Score);
                                                              T1.Interval:=speed;
                                                              L2.caption:=': '+IntToStr(spd);
                                                              x:=4; y:=1;
                                                              New;
                                                              end;
4: If (y+2<m)and(p[x,y+1].color=g)and(p[x+1,y+3].color=g)
                                                         then begin
                                                              col:=g; LeftCorner1;
                                                              y:=y+1;
                                                              col:=r; LeftCorner1;
                                                              end else
                                                              begin
                                                              proverka;
                                                              L1.caption:=': '+IntToStr(Score);
                                                              T1.Interval:=speed;
                                                              L2.caption:=': '+IntToStr(spd);
                                                              x:=4; y:=1;
                                                              New;
                                                              end;
5: If (y+1<m)and(p[x,y+2].color=g)and(p[x+1,y+2].color=g)and(p[x+2,y+2].color=g)
                                                         then begin
                                                              col:=g; LeftCorner2;
                                                              y:=y+1;
                                                              col:=r; LeftCorner2;
                                                              end else
                                                              begin
                                                              proverka;
                                                              L1.caption:=': '+IntToStr(Score);
                                                              T1.Interval:=speed;
                                                              L2.caption:=': '+IntToStr(spd);
                                                              x:=4; y:=1;
                                                              New;
                                                              end;
6: If (y+2<m)and(p[x,y+3].color=g)and(p[x+1,y+3].color=g)
                                                         then begin
                                                              col:=g; LeftCorner3;
                                                              y:=y+1;
                                                              col:=r; LeftCorner3;
                                                              end else
                                                              begin
                                                              proverka;
                                                              L1.caption:=': '+IntToStr(Score);
                                                              T1.Interval:=speed;
                                                              L2.caption:=': '+IntToStr(spd);
                                                              x:=4; y:=1;
                                                              New;
                                                              end;
7: If (y+1<m)and(p[x,y+2].color=g)and(p[x+1,y+1].color=g)and(p[x+2,y+1].color=g)
                                                         then begin
                                                              col:=g; LeftCorner4;
                                                              y:=y+1;
                                                              col:=r; LeftCorner4;
                                                              end else
                                                              begin
                                                              proverka;
                                                              L1.caption:=': '+IntToStr(Score);
                                                              T1.Interval:=speed;
                                                              L2.caption:=': '+IntToStr(spd);
                                                              x:=4; y:=1;
                                                              New;
                                                              end;
8: If (y+2<m)and(p[x,y+3].color=g)and(p[x+1,y+1].color=g)
                                                         then begin
                                                              col:=g; RightCorner1;
                                                              y:=y+1;
                                                              col:=r; RightCorner1;
                                                              end else
                                                              begin
                                                              proverka;
                                                              L1.caption:=': '+IntToStr(Score);
                                                              T1.Interval:=speed;
                                                              L2.caption:=': '+IntToStr(spd);
                                                              x:=4; y:=1;
                                                              New;
                                                              end;
9: If (y+1<m)and(p[x,y+1].color=g)and(p[x+1,y+1].color=g)and(p[x+2,y+2].color=g)
                                                         then begin
                                                              col:=g; RightCorner2;
                                                              y:=y+1;
                                                              col:=r; RightCorner2;
                                                              end else
                                                              begin
                                                              proverka;
                                                              L1.caption:=': '+IntToStr(Score);
                                                              T1.Interval:=speed;
                                                              L2.caption:=': '+IntToStr(spd);
                                                              x:=4; y:=1;
                                                              New;
                                                              end;
10:If (y+2<m)and(p[x,y+3].color=g)and(p[x+1,y+3].color=g)
                                                         then begin
                                                              col:=g; RightCorner3;
                                                              y:=y+1;
                                                              col:=r; RightCorner3;
                                                              end else
                                                              begin
                                                              proverka;
                                                              L1.caption:=': '+IntToStr(Score);
                                                              T1.Interval:=speed;
                                                              L2.caption:=': '+IntToStr(spd);
                                                              x:=4; y:=1;
                                                              New;
                                                              end;
11:If (y+1<m)and(p[x,y+2].color=g)and(p[x+1,y+2].color=g)and(p[x+2,y+2].color=g)
                                                         then begin
                                                              col:=g; RightCorner4;
                                                              y:=y+1;
                                                              col:=r; RightCorner4;
                                                              end else
                                                              begin
                                                              proverka;
                                                              L1.caption:=': '+IntToStr(Score);
                                                              T1.Interval:=speed;
                                                              L2.caption:=': '+IntToStr(spd);
                                                              x:=4; y:=1;
                                                              New;
                                                              end;
12:If (y+1<m)and(p[x,y+1].color=g)and(p[x+1,y+2].color=g)and(p[x+2,y+2].color=g)
                                                         then begin
                                                              col:=g; LeftZigzag1;
                                                              y:=y+1;
                                                              col:=r; LeftZigzag1;
                                                              end else
                                                              begin
                                                              proverka;
                                                              L1.caption:=': '+IntToStr(Score);
                                                              T1.Interval:=speed;
                                                              L2.caption:=': '+IntToStr(spd);
                                                              x:=4; y:=1;
                                                              New;
                                                              end;
13:If (y+2<m)and(p[x,y+3].color=g)and(p[x+1,y+2].color=g)
                                                         then begin
                                                              col:=g; LeftZigzag2;
                                                              y:=y+1;
                                                              col:=r; LeftZigzag2;
                                                              end else
                                                              begin
                                                              proverka;
                                                              L1.caption:=': '+IntToStr(Score);
                                                              T1.Interval:=speed;
                                                              L2.caption:=': '+IntToStr(spd);
                                                              x:=4; y:=1;
                                                              New;
                                                              end;
14:If (y+1<m)and(p[x,y+2].color=g)and(p[x+1,y+2].color=g)and(p[x+2,y+1].color=g)
                                                         then begin
                                                              col:=g; RightZigzag1;
                                                              y:=y+1;
                                                              col:=r; RightZigzag1;
                                                              end else
                                                              begin
                                                              proverka;
                                                              L1.caption:=': '+IntToStr(Score);
                                                              T1.Interval:=speed;
                                                              L2.caption:=': '+IntToStr(spd);
                                                              x:=4; y:=1;
                                                              New;
                                                              end;
15:If (y+2<m)and(p[x,y+2].color=g)and(p[x+1,y+3].color=g)
                                                         then begin
                                                              col:=g; RightZigzag2;
                                                              y:=y+1;
                                                              col:=r; RightZigzag2;
                                                              end else
                                                              begin
                                                              proverka;
                                                              L1.caption:=': '+IntToStr(Score);
                                                              T1.Interval:=speed;
                                                              L2.caption:=': '+IntToStr(spd);
                                                              x:=4; y:=1;
                                                              New;
                                                              end;
16:If (y+1<m)and(p[x,y+2].color=g)and(p[x+1,y+2].color=g)and(p[x+2,y+2].color=g)
                                                         then begin
                                                              col:=g; Triada1;
                                                              y:=y+1;
                                                              col:=r; Triada1;
                                                              end else
                                                              begin
                                                              proverka;
                                                              L1.caption:=': '+IntToStr(Score);
                                                              T1.Interval:=speed;
                                                              L2.caption:=': '+IntToStr(spd);
                                                              x:=4; y:=1;
                                                              New;
                                                              end;
17:If (y+2<m)and(p[x,y+3].color=g)and(p[x+1,y+2].color=g)
                                                         then begin
                                                              col:=g; Triada2;
                                                              y:=y+1;
                                                              col:=r; Triada2;
                                                              end else
                                                              begin
                                                              proverka;
                                                              L1.caption:=': '+IntToStr(Score);
                                                              T1.Interval:=speed;
                                                              L2.caption:=': '+IntToStr(spd);
                                                              x:=4; y:=1;
                                                              New;
                                                              end;
18:If (y+1<m)and(p[x,y+1].color=g)and(p[x+1,y+2].color=g)and(p[x+2,y+1].color=g)
                                                         then begin
                                                              col:=g; Triada3;
                                                              y:=y+1;
                                                              col:=r; Triada3;
                                                              end else
                                                              begin
                                                              proverka;
                                                              L1.caption:=': '+IntToStr(Score);
                                                              T1.Interval:=speed;
                                                              L2.caption:=': '+IntToStr(spd);
                                                              x:=4; y:=1;
                                                              New;
                                                              end;
19:If (y+2<m)and(p[x,y+2].color=g)and(p[x+1,y+3].color=g)
                                                         then begin
                                                              col:=g; Triada4;
                                                              y:=y+1;
                                                              col:=r; Triada4;
                                                              end else
                                                              begin
                                                              proverka;
                                                              L1.caption:=': '+IntToStr(Score);
                                                              T1.Interval:=speed;
                                                              L2.caption:=': '+IntToStr(spd);
                                                              x:=4; y:=1;
                                                              New;
                                                              end;


end;//of case

end;


procedure TForm1.SB1Click(Sender: TObject);
begin
GameOver;
New;
L1.caption:=': '+IntToStr(score);
L2.Caption:=': '+IntToStr(spd);
end;

procedure TForm1.SB2Click(Sender: TObject);
begin
T1.Enabled:=not T1.enabled;
If T1.Enabled then begin
                   SB2.caption:=' (Enter)';
                   SB2.Hint:=' (Enter)';
                   Form1.N3.Caption:='';
                   end
                   else begin
                   SB2.caption:=' (Enter)';
                   SB2.Hint:=' (Enter)';
                   Form1.N3.Caption:='';
                   end;
end;

procedure TForm1.SB3Click(Sender: TObject);
begin
Form1.close;
end;

procedure TForm1.N6Click(Sender: TObject);
begin
T1.enabled:=false;
SB2.caption:=' (Enter)';
Form1.N3.caption:=' (Enter)';
Form2.ShowModal;
end;

procedure TForm1.N7Click(Sender: TObject);
begin
T1.enabled:=false;
SB2.caption:=' (Enter)';
Form1.N3.caption:=' (Enter)';
Form3.ShowModal;
end;

initialization randomize;
end.






